
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: CPSSyndication.py,v 1.10 2002/09/23 13:56:10 jalon Exp $

"""
  CPSSyndication
"""


import string

import urllib,socket,httplib
import os,stat,string,posixfile
import sys, traceback

from xml.xslt.Processor import Processor



from Globals import InitializeClass
from AccessControl import ClassSecurityInfo

from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent



from Products.NuxCPSDocuments.BaseDocument import BaseDocument, BaseDocument_adder



factory_type_information = (
    {'id': 'CPSSyndication',
     'description': 'A CPSSyndication object  is editable through the web.',
     'title': 'CPSSyndication',
     'content_icon': '',
     'product': 'CPSSyndication',
     'factory': 'addCPSSyndication',
     'meta_type': 'CPSSyndication',
     'immediate_view': 'CPSSyndication_edit_form',
     'allow_discussion': 1,
     'filter_content_types': 0,
     'actions': ({'id': 'view',
                  'name': '_action_view_',
                  'action': 'CPSSyndication_view',
                  'permissions': (View,)},
                 {'id': 'edit',
                  'name': '_action_modify_',
                  'action': 'CPSSyndication_edit_form',
                  'permissions': (ModifyPortalContent,)},
                 {'id': 'create',
                  'name': '_action_create_',
                  'action': 'CPSSyndication_create_form',
                  'visible': 0,
                  'permissions': ()},
                 {'id': 'isdocument',
                  'name': 'isdocument',
                  'action': 'isdocument',
                  'visible': 0,
                  'permissions': ()},
                 {'id': 'issearchabledocument',
                  'name': 'issearchabledocument',
                  'action': 'issearchabledocument',
                  'visible': 0,
                  'permissions': ()},
                 ),
     },
    )



class CPSSyndication(BaseDocument):
    """
    CPSSyndication 
    """
    meta_type = 'CPSSyndication'

    security = ClassSecurityInfo()

    _properties = BaseDocument._properties + (
        {'id':'server', 'type':'string', 'mode':'w', 'label':'Server'},
        {'id':'web_path', 'type':'string', 'mode':'w', 'label':'Web_path'},
        {'id':'port', 'type':'string', 'mode':'w', 'label':'Port'},
	{'id':'feuille', 'type':'string', 'mode':'w', 'label':'Feuille'},
        )
    server = ''
    web_path = ''
    port = ''
    feuille = ''
    
    compiled=0
    updated=0 

    security.declareProtected(View, 'SearchableText')
    def SearchableText(self):
        """
        Used by the catalog for basic full text indexing.
        """
        return '%s %s %s %s' % (self.title,
                                self.description,
                                self.related_links)



    def transform(self, client=None, REQUEST={}, RESPONSE=None, **kw):
        """  """


        try:
            h = httplib.HTTP("%s:%s" % (self.server,self.port,))

            QUERY_STRING = urllib.urlencode(self.REQUEST.form)

            h.putrequest('GET', '%s?%s' % (self.web_path, QUERY_STRING))

            h.putheader('Accept', 'text/html')
            h.putheader('Accept', 'text/plain')
            h.endheaders()
            errcode, errmsg, headers = h.getreply()
            if errcode==200: self.compiled=1
            f = h.getfile()
            data = f.read()
            f.close()
        except:
            type, val, tb = sys.exc_info()
            data="""
<html>
<body bgcolor="eeeeff">
<font color="red">
An error occured!<br>
To fix problem:
</font>
<hr>
<pre>
%s
</pre>
</body>
</html>
""" % (string.join(traceback.format_exception(type, val, tb), ''),)
            del type, val, tb

        
	try:
            xsltproc = Processor()
            xsltproc.appendStylesheetString(self.feuille)
            res = xsltproc.runString(data)
        except:
	    pass

        return  res



InitializeClass(CPSSyndication)


def addCPSSyndication(dispatcher, id, REQUEST=None, **kw):
    """Add a CPSSyndication."""
    ob = CPSSyndication(id, **kw)
    
    return BaseDocument_adder(dispatcher, id, ob, REQUEST=REQUEST)

